import junit.framework.* ;

/**
 * The test class LineTest.
 *
 * @author  DB, modify AM
 * @version (a version number or a date)
 */

public class LineTest extends junit.framework.TestCase {

    private  Line d1;
    private  Line d2;

    /**
     * Default constructor for test class LineTest
     */
    public LineTest() {
    }

    /**
     * Sets up the test fixture.
     * Called before every test case method.
     */
    protected void setUp() {
    }

    /**
     * Tears down the test fixture.
     * Called after every test case method.
     */
    protected void tearDown() {
    }
    

    // As many Test Cases as necessary can now be written.
    
    /**
     * Tests the method relativePosition()
     */
    public void testPosition_IDENTICAL() {
        d1 = new Line( 1, 2, 3 );
        d2 = new Line( 3, 6, 9 );
        assertEquals( "IDENTICAL", d1.relativePosition( d2 ) );
        assertEquals( "IDENTICAL", d2.relativePosition( d1 ) );
        d1 = new Line( 2, 0, 3 );
        d2 = new Line( 6, 0, 9 );
        assertEquals( "IDENTICAL", d1.relativePosition( d2 ) );
        assertEquals( "IDENTICAL", d2.relativePosition( d1 ) );
        d1 = new Line( 0, 2, 3 );
        d2 = new Line( 0, -4, -6 );
        assertEquals( "IDENTICAL", d1.relativePosition( d2 ) );
        assertEquals( "IDENTICAL", d2.relativePosition( d1 ) );
	} 

	public void testPosition_PARALLEL()	{
	    d1 = new Line( 1, 2, -3 );
	    d2 = new Line( 3, 6, -3 );
	    assertEquals( "PARALLEL", d1.relativePosition( d2 ) );
	    assertEquals( "PARALLEL", d2.relativePosition( d1 ) );
	    d1 = new Line( 2, 0, 3 );
	    d2 = new Line( 9, 0, 5 );
	    assertEquals( "PARALLEL", d1.relativePosition( d2 ) );
	    assertEquals( "PARALLEL", d2.relativePosition( d1 ) );
	    d1 = new Line( 0, 2, 3 );
	    d2 = new Line( 0, 9, 5 );
	    assertEquals( "PARALLEL", d1.relativePosition( d2 ) );
	    assertEquals( "PARALLEL", d2.relativePosition( d1 ) );
	}

	public void testPosition_PERPENDICULAR() {
	    d1 = new Line( 2, 2, 0 );
	    d2 = new Line( 1, -1, 1 );
	    assertEquals( "PERPENDICULAR", d1.relativePosition( d2 ) );
	    assertEquals( "PERPENDICULAR", d2.relativePosition( d1 ) );
	    d1 = new Line( 2, 0, 3 );
	    d2 = new Line( 0, 9, 5 );
	    assertEquals( "PERPENDICULAR", d1.relativePosition( d2 ) );
	    assertEquals( "PERPENDICULAR", d2.relativePosition( d1 ) );
	}

	public void testPosition_SECANT() {
	    d1 = new Line( 0, 1, -2 );
	    d2 = new Line( 1, -2, 0 );
	    assertEquals( "SECANT", d1.relativePosition( d2 ) );
	    assertEquals( "SECANT", d2.relativePosition( d1 ) );
	}

	public void testPosition_Error () { // case not a line
	    d1 = new Line( 0, 0, 9 );
	    d2 = new Line( 1, 1, 1 );
	    assertEquals( d1+" is not a line !\n", "", d1.relativePosition( d2 ) );
	    assertEquals( d1+" is not a line !\n", "", d2.relativePosition( d1 ) );
	    d1 = new Line( 0, 0, 0 );
	    assertEquals( d1+" is not a line !\n", "", d1.relativePosition( d2 ) );
	    assertEquals( d1+" is not a line !\n", "", d2.relativePosition( d1 ) );
	} 

} // end class LineTest
